var speed_limit = 10;
var speed_increase = 1;
var jump_acceleration = 15;
var gravity = 0.7;
var lvlLoaded = false;
var headX = 0;
var headY = 0;
var stop = false;

var req = new XMLHttpRequest();
var lvlTest;
var collisionBlocks = [];
var crests = [];
var clouds = [];
var over = [];
var caught = 0;
var target = 0;
var width, height;
var sp;
var sky,play, overl; //Layers

function createOverCloud(y,x){
  //Draw overlay to hide crest
  var tmpBlock = new sjs.Sprite("data/OverCloud.png", overl);
  tmpBlock.realx = (x-3)*64;
  tmpBlock.realy = (y-3)*64;
  
  tmpBlock.rotate(Math.random()*Math.PI*4);
  tmpBlock.scale(0.5,0.5);
  

  /*var test = Math.random();

  if(test < 0.25){
    tmpBlock.scale(-0.5,0.5);
  }else if(test < 0.5){
    tmpBlock.scale(0.5,-0.5);
  }else if(test < 0.75){
    tmpBlock.scale(-0.5,-0.5);
  }*/

  tmpBlock.update();

  over.push(tmpBlock);
};

function createCollisionBlock(y,x){
  var tmpBlock = new sjs.Sprite("data/colBlock.png");
  tmpBlock.realx = x*64;
  tmpBlock.realy = y*64;

  tmpBlock.x = x*64;
  tmpBlock.y = y*64;

  tmpBlock.update();

  collisionBlocks.push(tmpBlock);
};

function createCrest(y,x){
  var tmpBlock = new sjs.Sprite("data/AirCrestIcon.png", play);
  tmpBlock.realx = x*64;
  tmpBlock.realy = y*64;

  tmpBlock.x = x*64;
  tmpBlock.y = y*64;

  tmpBlock.update();
  target++;

  crests.push(tmpBlock);
  if(Math.random() > 0.5){
    createOverCloud(y,x);
  }
};

function levelLoaded(){
  if (req.readyState == 4){
      //alert(req.responseText);
      lvlText = req.responseText;

      var lines = lvlText.split("\n");
      var size = lines[0].split(" ");
      
      width = size[0];
      height = size[1];

      for(var i = 1; i <= height; i++){
        //alert(lines[i].length);
        for(var j=0; j < width; j++){
          if(lines[i].charAt(j) == '#'){
            createCollisionBlock(i-1,j)
            //alert(""+i+","+j);
          }else if(lines[i].charAt(j) == "P"){
            sp = new sjs.Sprite("data/SmRight.png",play);
            sp.realx = (j)*64;
            sp.x = (j)*64;
            sp.realy = (i-1)*64;
            sp.y = (i-1)*64;
            sp.update();

          }else if(lines[i].charAt(j) == "C"){
            createCrest(i-1,j);
          }
        }
      }
      lvlLoaded = true;
  }
};

function loadLevel(name){
  req.onreadystatechange = levelLoaded;
  req.open("GET", "data/level1.txt",false);
  req.send(null);
}

window.onload = function(){
  //var playarea = new sjs.Layer('playarea')
  sky = new sjs.Layer("sky");
  var grd = new sjs.Layer("grd");
  play = new sjs.Layer("play");
  overl = new sjs.Layer("over");

  var skyTile = new sjs.Sprite("data/solidSky.png",sky);
  skyTile.w = sjs.w;
  skyTile.h = sjs.h;
  skyTile.update();

  var ground = new sjs.Sprite("data/level1.png",grd);
    
  loadLevel("level1");
  var numClouds = 100;//Math.floor(Math.random()*(height*width/5));
  
  var overClouds = 20;

  var audio = document.getElementById("jump");
  var item = document.getElementById("item");

  var result = document.getElementById("result");

  for(var i=0; i < overClouds; i++){
    createOverCloud(Math.floor(Math.random()*height), Math.floor(Math.random()*width));
  }

  for(var i=0; i < numClouds; i++){
    y = Math.random()*(height*64);
    x = Math.random()*(width*64);
    speed = Math.random()*0.2;

    if(Math.random() > 0.5){
      speed = -speed;
    }

    
    var tmpBlock = new sjs.Sprite("data/cloud1.png",sky);
    tmpBlock.realy = y;
    tmpBlock.realx = x;

    if(Math.random() > 0.5){
      tmpBlock.scale(-1,1);
    }

    clouds.push([tmpBlock, speed]);
  }

  var input = new sjs.Input();

  var direction = "Right"
  var back = "";
  var yv = 0;
  var xv = 0;

  var jumping = true;

  function update(){
   
    yv += gravity; //Gravity
    
    if(input.keyboard.right){
      //sp.move(10,0);
      xv += speed_increase;
      direction = "Right";
    }

    if(input.keyboard.left){
      //sp.move(-10,0);
      xv -= speed_increase;
      direction = "Left";
    }

   
    if(input.arrows()){
      sp.loadImg("data/Sm"+direction+".png");
    }else{
      xv = 0;
    }
    
    if(Math.abs(xv) > speed_limit){
      if(direction == "Right"){
        xv = speed_limit;
      }else{
        xv = -speed_limit;
      }
    }
    

    for(var i in crests){
      if(sp.collidesWith(crests[i])){
        crests[i].remove()
        crests.splice(i,1);
        caught++;
        item.play();
        result.innerHtml = "<h4>"+caught+"/"+target+"</h4>";
        //alert("caught crest");
        if(caught == target){
          alert("You caught all the crests! The power of wind can now be safely taken to your home planet");
          var el = document.getElementById("sjs");
          var p = el.parentNode;
          el.parentNode.removeChild(el);
          var n = document.createElement("div");
          n.setAttribute("style",'background-color:#0079e6;text-align:center;');
          n.innerHTML="<p>Congratulations! You found all the crests! The power of wind can now be safely taken to your planet</p><br/><img src='data/end.png' width=800/>";
          p.appendChild(n);

        }
      }
    }

    var hitCeiling = false;
    var hits = 0;
    for(var i in collisionBlocks){
      if(sp.collidesWith(collisionBlocks[i])){
        if(Math.abs(collisionBlocks[i].x - sp.x) < 50){
           yv = 0;
           jumping = false;
           if(collisionBlocks[i].y < sp.y){
             hits++;
           }
        }

        if(hits > 0){
          hitCeiling = true;
          yv += gravity*2;
          jumping  = true;
        }
        
        if(Math.abs(collisionBlocks[i].y - sp.y) < 50){
          if(collisionBlocks[i].x < sp.x && direction == "Left"){
            xv = 0;
          }else if(collisionBlocks[i].x > sp.x && direction == "Right"){
            xv = 0;
          }
        }
      }
    }

    
     if(input.keyboard.up){
      if(!jumping && !hitCeiling){
        yv -= jump_acceleration;
        jumping = true;
        audio.play();
      }
    }

    sp.realx += xv;
    sp.realy += yv;

    if(sp.realx > (width-1)*64){
      sp.realx = (width-1)*64;
    }else if(sp.realx < 0){
      sp.realx = 0;
    }

    if(sp.realy > (height+2)*64){
      var el = document.getElementById("sjs");
          var p = el.parentNode;
          el.parentNode.removeChild(el);
          var n = document.createElement("div");
          n.setAttribute("style",';text-align:center;');
          n.innerHTML="<p>You died...refresh to try again :)";
          p.appendChild(n);

      stop = true;
    }

    if(stop){
      ticker.stop();
    }


    headX = sp.realx - sjs.w/2;
    headY = sp.realy - sjs.h/2;

    if(headX < 0){
      headX = 0;
    }else if(headX + sjs.w > width*64){
      headX = width*64 - sjs.w;
    }
    if(headY < 0){
      headY = 0;
    }else if(headY + sjs.h > height*64){
      headY = height*64 - sjs.h;
    }
    
    sp.x = sp.realx - headX;
    sp.y = sp.realy - headY;

    ground.x = ground.realx - headX;
    ground.y = ground.realy - headY;

    for(var i in collisionBlocks){
      collisionBlocks[i].x = collisionBlocks[i].realx - headX;
      collisionBlocks[i].y = collisionBlocks[i].realy - headY;
    }

    for(var i in crests){
      crests[i].x = crests[i].realx - headX;
      crests[i].y = crests[i].realy - headY;

      crests[i].update();

    }

     for(var i in clouds){
      clouds[i][0].realx += clouds[i][1];

      if(clouds[i][0].realx > width*64){
        clouds[i][0].realx = 0;
      }else if(clouds[i][0].realx < -200){
        clouds[i][0].realx = width*64;
      }

      clouds[i][0].x = clouds[i][0].realx - headX/2;
      clouds[i][0].y = clouds[i][0].realy - headY/2;

      clouds[i][0].update();
    }

    for(var i in over){
      over[i].x = over[i].realx - headX;
      over[i].y = over[i].realy - headY;

      over[i].update();
    }

    sp.update();
    ground.update();
    
  }
  var ticker = new sjs.Ticker(30,update);
  ticker.run();
};




